SystemOrganization addCategory: #MudTalk!
SystemOrganization addCategory: #'MudTalk-Client'!
SystemOrganization addCategory: #'MudTalk-Tests'!

TestCase subclass: #MudServerTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Tests'!

!MudServerTests methodsFor: 'tests' stamp: 'AlexanderSvyazin 10/16/2012 23:22'!
testStartStop
	|server|
	server := MudServer new.
	server start.
	self should: [server isStarted].
	self shouldnt: [server isStopped].
	server stop.
	self should: [server isStopped].
	self shouldnt: [server isStarted].! !

!MudServerTests methodsFor: 'tests' stamp: 'AlexanderSvyazin 10/12/2012 23:20'!
testState
	|server|
	server := MudServer new.
	self should: [server isStopped].
	self shouldnt: [server isStarted].! !

!FontFamilyMemberAbstract methodsFor: '*MudTalk-Client' stamp: 'AlexanderSvyazin 1/4/2013 20:56'!
isFixedWidth
	^ (self respondsTo: #fileInfo) ifFalse: [ false ]
		ifTrue: [ self fileInfo fixedWidth ]! !

!LogicalFontManager methodsFor: '*MudTalk-Client' stamp: 'AlexanderSvyazin 1/4/2013 21:22'!
fixedWidthFamilies
	^ self allFamilies select: [ :family |
		family members allSatisfy: [ :member | member isFixedWidth ] ].! !

PPToken subclass: #TelnetAoToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetAoToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:00'!
triggerOn: aEventManager
	aEventManager triggerEvent: #ao! !

PPToken subclass: #TelnetAytToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetAytToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:01'!
triggerOn: aEventManager
	aEventManager triggerEvent: #ayt! !

PPToken subclass: #TelnetBrkToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetBrkToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:02'!
triggerOn: aEventManager
	aEventManager triggerEvent: #brk! !

PPToken subclass: #TelnetDmToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetDmToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:02'!
triggerOn: aEventManager
	aEventManager triggerEvent: #dm! !

PPToken subclass: #TelnetDoToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetDoToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:56'!
triggerOn: aEventManager
	aEventManager triggerEvent: #do: with: (self value at: 1) asInteger.! !

PPToken subclass: #TelnetDontToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetDontToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:56'!
triggerOn: aEventManager
	aEventManager triggerEvent: #dont: with: (self value at: 1) asInteger.! !

PPToken subclass: #TelnetEcToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetEcToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:05'!
triggerOn: aEventManager
	aEventManager triggerEvent: #ec! !

PPToken subclass: #TelnetElToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetElToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:05'!
triggerOn: aEventManager
	aEventManager triggerEvent: #el! !

PPToken subclass: #TelnetEorToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetEorToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 14:46'!
triggerOn: aEventManager
	aEventManager triggerEvent: #eor! !

PPToken subclass: #TelnetGaToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetGaToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:06'!
triggerOn: aEventManager
	aEventManager triggerEvent: #ga! !

PPToken subclass: #TelnetIpToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetIpToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:06'!
triggerOn: aEventManager
	aEventManager triggerEvent: #ip! !

PPToken subclass: #TelnetNopToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetNopToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:07'!
triggerOn: aEventManager
	aEventManager triggerEvent: #nop! !

PPToken subclass: #TelnetSubmoduleToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetSubmoduleToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:11'!
triggerOn: aEventManager
	aEventManager triggerEvent: #submodule: with: self value.! !

PPToken subclass: #TelnetTextToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetTextToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 12:12'!
triggerOn: aEventManager
	aEventManager triggerEvent: #text: with: self value.! !

PPToken subclass: #TelnetWillToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetWillToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:56'!
triggerOn: aEventManager
	aEventManager triggerEvent: #will: with: (self value at: 1) asInteger.! !

PPToken subclass: #TelnetWontToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetWontToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:56'!
triggerOn: aEventManager
	aEventManager triggerEvent: #wont: with: (self value at: 1) asInteger.! !

Object subclass: #MudServer
	instanceVariableNames: 'started'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!MudServer methodsFor: 'initialize-release' stamp: 'AlexanderSvyazin 10/12/2012 23:23'!
initialize
	started := false.! !

!MudServer methodsFor: 'state' stamp: 'AlexanderSvyazin 10/12/2012 23:23'!
isStarted
	^ started.! !

!MudServer methodsFor: 'state' stamp: 'AlexanderSvyazin 10/12/2012 23:21'!
isStopped
	^ started not.! !

!MudServer methodsFor: 'start-stop' stamp: 'AlexanderSvyazin 10/12/2012 23:32'!
start
	started := true.! !

!MudServer methodsFor: 'start-stop' stamp: 'AlexanderSvyazin 10/12/2012 23:33'!
stop
	started := false.! !

Object subclass: #MudTalkClient
	instanceVariableNames: 'window inputPane outputPane outputContents connection doHandlers willHandlers font'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/2/2013 18:17'!
connectTo: aHost port: aPort 
	connection := MudTalkClientConnection new connectTo: aHost port: aPort.! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/4/2013 11:59'!
connection
	^ connection! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/4/2013 21:48'!
connectionClosedText
	^ '******* CONNECTION CLOSED *******' asText addAttribute: (TextColor color: Color red)! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/2/2013 20:49'!
disconnect
	connection ifNotNil: [ connection terminate ].! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/4/2013 21:48'!
disconnected
	self outputText: self connectionClosedText! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/4/2013 14:39'!
do: cmd
	doHandlers at: cmd
		ifPresent: [ :handler | handler value ]
		ifAbsent: [ self unknownDoOption: cmd ]! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/4/2013 21:32'!
fixedWidthFontFamily
	^ (LogicalFontManager current fixedWidthFamilies at: 1) familyName.! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/4/2013 21:29'!
font
	^ font ifNil: [
		font := LogicalFont familyName: (self fixedWidthFontFamily) pointSize: self fontSize]! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/4/2013 21:29'!
fontSize
	^ 10.! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 17:48'!
getInput
	^nil.! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 18:10'!
host
	^ NetNameResolver addressFromString: '10.240.1.10'.! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/4/2013 14:25'!
initialize
	super initialize.
	self initializeDoHandlers.
	self initializeWillHandlers.
	self installInputPane.
	self installOutputPane.
	self initializeConnection.
	self window openInWorld.
	self inputPane takeKeyboardFocus.! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/4/2013 21:42'!
initializeConnection
	self connectTo: self host port: self port.
	connection events
		when: #disconnected send: #disconnected to: self;
		when: #text: send: #text: to: self;
		when: #do: send: #do: to: self;
		when: #dont: send: #dont: to: self;
		when: #will: send: #will: to: self;
		when: #wont: send: #wont: to: self;
		when: #submodule: send: #submodule: to: self;
		when: #nop send: #nop to: self;
		when: #dm send: #dm to: self;
		when: #brk send: #brk to: self;
		when: #ip send: #ip to: self;
		when: #ao send: #ao to: self;
		when: #ayt send: #ayt to: self;
		when: #ec send: #ec to: self;
		when: #el send: #el to: self;
		when: #ga send: #ga to: self! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/4/2013 13:26'!
initializeDoHandlers
	doHandlers := Dictionary new.
	doHandlers at: TelnetOption suppressGoAhead put: [self willSuppressGoAhead].! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/4/2013 13:21'!
initializeWillHandlers
	willHandlers := Dictionary new.! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/4/2013 21:26'!
inputPane
	^ inputPane ifNil: [
		inputPane := self window newTextEditorFor: self getText: #getInput setText: #sendCommand:.
		inputPane acceptOnCR: true;
			font: self font].! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/2/2013 17:02'!
installInputPane
	self window
		addMorph: self inputPane
		fullFrame: (LayoutFrame fractions: (0@0.5 extent: 1@1)).! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/2/2013 17:04'!
installOutputPane
	self window
		addMorph: self outputPane
		fullFrame: (LayoutFrame fractions: (0@0 extent: 1@0.5)).! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 17:39'!
outputContents
	^ outputContents ifNil: [
		outputContents := Text new].! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/4/2013 21:26'!
outputPane
	^ outputPane ifNil: [
		outputPane := self window newTextEditorFor: self getText: #outputContents setText: nil.
		outputPane font: self font].! !

!MudTalkClient methodsFor: 'outputting' stamp: 'AlexanderSvyazin 1/4/2013 17:51'!
outputText: aText
	self outputContents append: aText;
		append: String crlf.
	self changed: #outputContents.
	self outputPane scrollToBottom.! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 18:05'!
port
	^ 10101.! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/2/2013 21:14'!
sendCommand: aText
	connection sendText: aText.
	self changed: #getInput.! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/4/2013 12:13'!
text: line
	self outputText: line asText.! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/4/2013 14:40'!
unknownDoOption: cmd
	self trace: 'unknown DO option: ';
		traceCr: cmd.
	^ self connection sendWont: cmd! !

!MudTalkClient methodsFor: 'updating' stamp: 'AlexanderSvyazin 1/4/2013 14:40'!
unknownWillOption: cmd
	self trace: 'unknown WILL option: ';
		traceCr: cmd.
	^ self connection sendDont: cmd! !

!MudTalkClient methodsFor: 'updating' stamp: 'AlexanderSvyazin 1/4/2013 14:39'!
will: cmd
	willHandlers at: cmd
		ifPresent: [ :handler | handler value ]
		ifAbsent: [ self unknownWillOption: cmd ]! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/4/2013 13:28'!
willSuppressGoAhead
	self connection sendWill: TelnetOption suppressGoAhead.! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 16:34'!
window
	^ window ifNil: [
		window := StandardWindow labelled: 'MUD client']! !

Object subclass: #MudTalkClientConnection
	instanceVariableNames: 'stream readingProcess events parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClientConnection methodsFor: 'events' stamp: 'AlexanderSvyazin 1/2/2013 20:48'!
connectTo: aHost port: aPort 
	stream := SocketStream openConnectionToHost: aHost port: aPort.
	readingProcess := [self networkReadLoop] forkNamed: 'MUD client network reading process'.! !

!MudTalkClientConnection methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/4/2013 14:59'!
events
	^ events ifNil: [ self newEvents ]! !

!MudTalkClientConnection methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 15:52'!
initialize
	super initialize.
	parser := TelnetParser parser.! !

!MudTalkClientConnection methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/4/2013 21:41'!
networkReadLoop
	[ [ self processLineFromServer ] repeat ]
		on: NetworkError
		do: [ self events triggerEvent: #disconnected ]! !

!MudTalkClientConnection methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/4/2013 15:51'!
newEvents
	events := EventManager new.
	^ events! !

!MudTalkClientConnection methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/4/2013 21:40'!
nextLine
	^ stream nextLine! !

!MudTalkClientConnection methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/4/2013 14:51'!
processLineFromServer
	| line parsedLine |
	line := self nextLine.
	parsedLine := parser parse: line.
	parsedLine do: [ :token | token triggerOn: self events ]! !

!MudTalkClientConnection methodsFor: 'read' stamp: 'AlexanderSvyazin 1/4/2013 15:10'!
sendDo: option
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser doChar;
		nextPut: (Character value: option);
		flush.! !

!MudTalkClientConnection methodsFor: 'read' stamp: 'AlexanderSvyazin 1/4/2013 15:10'!
sendDont: option 
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser dontChar;
		nextPut: (Character value: option);
		flush.! !

!MudTalkClientConnection methodsFor: 'read' stamp: 'AlexanderSvyazin 1/4/2013 15:10'!
sendSubmodule: aByteArray
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser sbChar;
		nextPutAll: aByteArray;
		nextPut: TelnetParser iacChar;
		nextPut: TelnetParser seChar;
		flush.! !

!MudTalkClientConnection methodsFor: 'read' stamp: 'AlexanderSvyazin 1/4/2013 15:50'!
sendText: aText
	stream nextPutAll: aText; crlf; flush! !

!MudTalkClientConnection methodsFor: 'read' stamp: 'AlexanderSvyazin 1/4/2013 15:11'!
sendWill: option 
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser willChar;
		nextPut: (Character value: option);
		flush.! !

!MudTalkClientConnection methodsFor: 'read' stamp: 'AlexanderSvyazin 1/4/2013 15:11'!
sendWont: option
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser wontChar;
		nextPut: (Character value: option);
		flush.! !

!MudTalkClientConnection methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 20:49'!
terminateReadingProcess
	readingProcess ifNotNil: [ readingProcess terminate ]! !

Object subclass: #TelnetOption
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 15:29'!
eor
	^ 25.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 13:27'!
suppressGoAhead
	^ 3.! !

Object subclass: #TelnetParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/3/2013 23:04'!
anyToken: aTokenClass
	^ #any asParser token: aTokenClass.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 10:55'!
ao
	^ (TelnetParser iac , TelnetParser aoChar asParser) token: TelnetAoToken! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
aoChar
	^ Character value: 245.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 10:55'!
ayt
 	^ (TelnetParser iac , TelnetParser aytChar asParser) token: TelnetAytToken! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
aytChar
	^ Character value: 246.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 10:54'!
brk
	^ (TelnetParser iac , TelnetParser brkChar asParser) token: TelnetBrkToken! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
brkChar
	^ Character value: 243.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 10:54'!
dm
	^ (TelnetParser iac , TelnetParser dmChar asParser) token: TelnetDmToken! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
dmChar
	^ Character value: 242.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/3/2013 23:00'!
do
	^ (TelnetParser iac,
		TelnetParser doChar asParser,
		(TelnetParser anyToken: TelnetDoToken)) ==>
			[:parts | parts at: 3].! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
doChar
	^ Character value: 253.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/3/2013 23:01'!
dont
	^ (TelnetParser iac,
		TelnetParser dontChar asParser,
		(TelnetParser anyToken: TelnetDontToken)) ==>
			[:parts | parts at: 3].! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
dontChar
	^ Character value: 254.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 10:54'!
ec
	^ (TelnetParser iac , TelnetParser ecChar asParser) token: TelnetEcToken! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
ecChar
	^ Character value: 247.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 10:54'!
el
	^ (TelnetParser iac , TelnetParser elChar asParser) token: TelnetElToken! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
elChar
	^ Character value: 248.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 14:45'!
eor
	^ (TelnetParser iac, TelnetParser eorChar asParser) token: TelnetEorToken.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 14:44'!
eorChar
	^ Character value: 239.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 15:33'!
eorDelimiter
	^ String with: TelnetParser iacChar with: TelnetParser eorChar.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 10:53'!
ga
	^ (TelnetParser iac , TelnetParser gaChar asParser) token: TelnetGaToken! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
gaChar
	^ Character value: 249.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/3/2013 22:52'!
iac
	^ TelnetParser iacChar asParser.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
iacChar
	^ Character value: 255.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/3/2013 23:04'!
iaciac
	^ (TelnetParser iac, TelnetParser iac)
		answer: TelnetParser iacChar.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 10:53'!
ip
	^ (TelnetParser iac , TelnetParser ipChar asParser) token: TelnetIpToken! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
ipChar
	^ Character value: 244.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 10:53'!
nop
	^ (TelnetParser iac , TelnetParser nopChar asParser) token: TelnetNopToken! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
nopChar
	^ Character value: 241.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/3/2013 23:08'!
normalChar
	^ TelnetParser iaciac / TelnetParser iac negate.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/3/2013 22:45'!
parser
	^ (TelnetParser special / TelnetParser text) star end.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/3/2013 22:00'!
sb
	^ TelnetParser sbChar asParser.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
sbChar
	^ Character value: 250.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/3/2013 22:00'!
se
	^ TelnetParser seChar asParser.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
seChar
	^ Character value: 240.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/3/2013 22:51'!
special
	^ TelnetParser nop /
		TelnetParser dm /
		TelnetParser brk /
		TelnetParser ip /
		TelnetParser ao /
		TelnetParser ayt /
		TelnetParser ec /
		TelnetParser el /
		TelnetParser ga /
		TelnetParser do /
		TelnetParser dont /
		TelnetParser will /
		TelnetParser wont /
		TelnetParser submodule.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/3/2013 22:55'!
submodule
	^ TelnetParser sb, (#any asParser plus token: TelnetSubmoduleToken), TelnetParser se ==>
		[:parts | parts at: 2].! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 10:46'!
text
	^ TelnetParser normalChar plus ==> [:chars | TelnetTextToken on: (String withAll: chars)].! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/3/2013 23:01'!
will
	^ (TelnetParser iac,
		TelnetParser willChar asParser,
		(TelnetParser anyToken: TelnetWillToken)) ==>
			[:parts | parts at: 3].! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/4/2013 11:31'!
willChar
	^ Character value: 251.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/3/2013 23:01'!
wont
	^ (TelnetParser iac,
		TelnetParser wontChar asParser,
		(TelnetParser anyToken: TelnetWontToken)) ==>
			[:parts | parts at: 3].! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
wontChar
	^ Character value: 252.! !
